require 'sketchup.rb'

class Clf_line_tool

	def activate
		@p1 = nil
		@p2 = nil
		@cursor_pos = nil
		@ipmmpos = nil # Input Point Move Mouse Position
	end
	
	def make_line
		ents = Sketchup.active_model.active_entities
		ents.add_edges( @p1, @p2 )
	end

	def onLButtonUp(flags, x, y, view)
		if (@p1)
			inputpoint = view.inputpoint x, y
			inputpoint.pick view, x, y
			@p2 = @p1 
			@p1 = inputpoint.position
			make_line
		else
			inputpoint = view.inputpoint x, y
			inputpoint.pick view, x, y
			@p1 = inputpoint.position
		end
	end

	def onMouseMove(flags, x, y, view)
		if (@p1)
			@cursor_pos = [x,y]
			view.invalidate
			draw(view)
		end
	end

	def draw(view)            
		view.drawing_color="red"
		start_rubber = view.screen_coords(@p1)
		view = view.draw2d GL_LINES, [start_rubber, @cursor_pos]
	end
	
end


######
#Everything below here is only for the menu system.  It has nothing to do with the script really.
if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("**Line without Inference TEST**") { Sketchup.active_model.select_tool Clf_line_tool.new  }
	end
else
	if !file_loaded?('clf_menu_loader') then
		$clf_tools_menu = UI.menu("Plugins").add_submenu("Chris Fullmer Tools")
	end
	if !file_loaded?(__FILE__) then
		$clf_tools_menu.add_item("**Line without Inference TEST**") { Sketchup.active_model.select_tool Clf_line_tool.new }
	end
end

file_loaded('clf_menu_loader')
file_loaded(__FILE__)